#include <u.h>
#include <libc.h>
#include <bio.h>
#include "misc.h"

Biobuf bout;

void
usage(void)
{
	fprint(2,
	"usage: merge $file1 [$file2]\n"
	"currently very simple\n"
	);
	exits("usage");
}


void
main(int argc, char *argv[])
{
	int fd0, fd1;
	char *p0,*p1;
	Rdbuf *rb0, *rb1;

	ARGBEGIN{
	default: usage();
	}ARGEND

	if(*argv == nil)
		usage();

	Binit(&bout, 1, OWRITE);

	if(argc == 0 || argc > 2)
		usage();

	fd0 = open(argv[0], OREAD);
	if(fd0 < 0)
		sysfatal("%s not open: %r",argv[0]);
	fd1 = 0;
	if(argv[1]){
		fd1 = open(argv[1], OREAD);
		if(fd1 < 0)
			sysfatal("%s not open: %r",argv[1]);
	}

	rb0 = rdinit(fd0, 32*1024);
	rb1 = rdinit(fd1, 32*1024);

	p0 = rdline(rb0);
	p1 = rdline(rb1);

	while(p0 && p1){
		if(strcmp(p0,p1) < 0){
			Bprint(&bout, "%s\n", p0);
			p0 = rdline(rb0);
			continue;
		}
		if(strcmp(p0,p1) > 0){
			Bprint(&bout, "%s\n", p1);
			p1 = rdline(rb1);
			continue;
		}
		if(strcmp(p0,p1) == 0){
			Bprint(&bout, "%s\n", p0);
			p0 = rdline(rb0);
			p1 = rdline(rb1);
			continue;
		}	
	}

	if(p0){
		Bprint(&bout, "%s\n", p0);
		while((p0 = rdline(rb0)))
			Bprint(&bout, "%s\n", p0);
		exits(nil);
	}
	if(p1){
		Bprint(&bout, "%s\n", p1);
		while((p1 = rdline(rb1)))
			Bprint(&bout, "%s\n", p1);
		exits(nil);
	}

	exits(nil);
}
