/*
*	unq: unquote
*
*	coded by Kenar(Kenji Arisawa)
*	E-mail: arisawa@aichi-u.ac.jp
*/

#include <u.h>
#include <libc.h>
#include <ctype.h>
#include <bio.h>

Biobuf	out;

enum
{
	NARGS = 16,
};

void
usage(void)
{
	fprint(2,"usage: unq [file ...]\n"
		"	unq unquote of rc style quote and put TAB as separator\n"
		);
	exits("usage");
}

static void
doit(char *file)
{
	int fd = 0;
	Biobuf in;
	char *line;
	char *args[NARGS];
	int n,m;
	if(file != nil){
		fd = open(file, OREAD);
		if(fd < 0)
			sysfatal("%s not open: %r", file);
	}
	Binit(&in, fd, OREAD);
	while(line = Brdstr(&in,'\n',1)){/* assign = */
		m = tokenize(line,args,NARGS);
		for(n = 0; n < m - 1; n++){
			Bprint(&out,"%s\t", args[n]);
		}
		if(m > 0)
			Bprint(&out,"%s\n", args[n]);
		else
			Bprint(&out,"\n");
	}
	Bterm(&in); // note: Bterm close the file
}


void
main(int argc, char *argv[])
{
	ARGBEGIN{
	default: usage();
	}ARGEND

	Binit(&out, 1, OWRITE);

	if(*argv == nil){
		doit(nil);
		exits(nil);
	}

	while(*argv)
		doit(*argv++);
	Bterm(&out);
	exits(nil);
}
